// $Id: content_type_selector.js,v 1.1.2.1 2009/04/28 22:13:21 markuspetrux Exp $

/**
 * @file
 * Content type selector to quickly switch from one type to another
 * in content type administration pages.
 */

Drupal.behaviors.contentTypeSelector = function(context) {
  $('#tabs-wrapper:not(.content-type-selector-processed)', context).addClass('content-type-selector').each(function() {
    var tabs = this, settings = Drupal.settings.contentTypeSelector;

    $(Drupal.theme('contentTypeSelector', settings)).appendTo(tabs);

    function goto() {
      var nodetype = $('#content-type-selector').val();
      if (nodetype && nodetype != settings.current) {
        window.location = settings.urlmask.replace(/NODETYPE/, nodetype);
      }
    }

    $('input=[name=content-type-selector-go]').bind('click', function() {
      goto();
      return false;
    });

    $('#content-type-selector').bind('change', function() {
      goto();
    });
  });
};

Drupal.theme.prototype.contentTypeSelector = function(settings) {
  var options = [];
  $.each(settings.types, function(value, label) {
    var selected = (value == settings.current ? ' selected="selected"' : '');
    options.push('<option value="'+ value +'"'+ selected +'>'+ label +'</option>');
  });
  return '<div id="content-type-selector-wrapper"><form method="post" action="javascript:void(0)">'
    +'<div class="form-item">'
      +'<label for="content-type-selector">'+ Drupal.t('Switch type:') +'</label>&nbsp;'
      +'<select name="content-type-selector" id="content-type-selector">'+ options.join('') +'</select>&nbsp;'
    +'</div>'
    +'<input type="submit" name="content-type-selector-go" value="'+ Drupal.t('Go') +'" class="form-submit" />'
    +'</form></div>';
};
